
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>jvm系列 (二) ---垃圾收集器与内存分配策略 / 憋错料</title>

    <meta name="description" content="jvm系列 (二) ---垃圾收集器与内存分配策略 回顾 上文介绍了jvm的内存区域以及介绍了内存的溢出情况. jvm区域分为5个,线程独有:虚拟机栈,本地方法栈,程序计数器.线程共享:方法区,堆 两种溢出:栈溢出(StackOverflowError),OutOfMemoryError(OOM) 为什么学习垃圾收集 看起来jvm好像一切帮你做好,但是当垃圾收集成为系统达到更高并发量的瓶颈时,我们就需要对这种自动化的技术进行监控和调节. 根据实际应用需求,选择最优的收集方式才能更高的性能. 垃圾收集的区域 虚拟机栈,本地方法栈,程序计数器是线程私">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">jvm系列 (二) ---垃圾收集器与内存分配策略</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>回顾</h2>
<ul>
<li>上文介绍了jvm的内存区域以及介绍了内存的溢出情况。</li>
<li>jvm区域分为5个，线程独有：虚拟机栈，本地方法栈，程序计数器。线程共享：方法区，堆</li>
<li>两种溢出：栈溢出（StackOverflowError），OutOfMemoryError（OOM）</li>
</ul>
<h2>为什么学习垃圾收集</h2>
<ul>
<li>看起来jvm好像一切帮你做好，但是当垃圾收集成为系统达到更高并发量的瓶颈时，我们就需要对这种自动化的技术进行监控和调节。</li>
<li>根据实际应用需求，选择最优的收集方式才能更高的性能。</li>
</ul>
<h2>垃圾收集的区域</h2>
<ul>
<li>虚拟机栈，本地方法栈，程序计数器是线程私有的，和线程同生共死，当线程销毁时，内存自然回收，所以这部分不是考虑的重点。</li>
<li>所以研究重点应该在方法区和堆，而方法区的回收效率较低，重点在堆。</li>
</ul>
<h1>确定回收对象</h1>
<h2>引用计数</h2>
<ul>
<li>对象有一个引用计数器 new String（）</li>
<li>有引用，计数器加一，String jiajun=new String（）</li>
<li>引用失效，计数器减一，jiajun=null；</li>
<li>出现一个问题
<pre><code>Person jia=new Persoon();
Person jun=new Person();
jia.bro=jun;
jun.bro=jia;
jia=null;
jun=null;</code></pre>
</li>
<li>此时虽然我们没有办法用jia和jun这两个对象，也就是这个是垃圾了，但是两个对象又互相引用，如果用这种算法是无法进行回收</li>
</ul>
<h2>可达性分析</h2>
<ul>
<li>GC Roots的对象：虚拟机栈中引用的对象（比如方法中定义的对象），本地方法栈中引用的对象，方法区中类静态属性引用的对象（static），方法区中常量应用的对象（final）</li>
<li>通过GC Roots对象作为起点，当GC Roots到一个对象没有引用链的话，那么就证明这个而对象不可用</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTI0MjI1NzQwLTIwMjE1NDg1ODIucG5n.jpg" /></p>
<h1>垃圾收集算法</h1>
<h2>标记清除</h2>
<ul>
<li>确定回收对象，进行标记，然后回收标记的对象</li>
<li>一个问题是标记清除效率不高</li>
<li>一个问题是标记清除后产生大量不连续的内存碎片，但需要分配较大对象的时候，因为没有足够大的连续空间分配给此对象，此时会触发另一次垃圾收集</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwNTE0Mzk3LTE3MTE5OTc1Mi5wbmc=.jpg" /></p>
<h2>复制</h2>
<ul>
<li>解决内存碎片的问题</li>
<li>将内存分为等大的A区和B区，创建对象时，存放于A区，当A区空间用完之后，将A区存活的对象复制到B区，然后A区清空，这样的话，就避免了内存碎片的问题</li>
<li>但是又有一个问题，这个时候我们只用到了一半的空间，所以我们要向办法提高空间利用率</li>
<li>研究发现，新生代对象大多都是朝生夕死，也就是存活的对象不多，那么我们就没必要分配一半的空间用于&ldquo;粘贴&rdquo;</li>
<li>所以虚拟机将新生代分为Eden和Surivior两个区，比例为8:1:1，可用的内存为一个伊甸区个一个存活区，一个存活区用于&ldquo;粘贴,&rdquo;，也就是新生代可用内存空间为容量的90%，这样的话就提高了空间了利用率</li>
<li>但是又有一个问题，如果这一个存活区存放不了复制的的对象，那么怎么办？于是，如果这些对象放不下，将直接进入另一块区域老年代</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwNTMyODY1LTE1OTA0MDk2NjcucG5n.jpg" /></p>
<h2>标记整理</h2>
<ul>
<li>对于朝生夕死的新生代来说，复制算法是不错的选择。但是对于存活率高的对象不是很好的选择，因为要进行较多的复制操作，效率会降低</li>
<li>过程：确定回收对象，进行标记，让存活的对象向一端移动，然后清理掉端边界以外的内存</li>
<li>那么这样的话，不会有内存碎片的问题，也没有复制过多效率降低的问题</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwNTQ3ODgxLTIwODYzNTQyMjYucG5n.jpg" /></p>
<h2>分代收集</h2>
<ul>
<li>上面几种方法的综合利用</li>
<li>根据新生代和老年代的特点，分别选用适用的算法。</li>
<li>新生代存活率，那么可以选择复制算法</li>
<li>老年代存活率高，可以采用标记清理或标记整理算法</li>
</ul>
<h1>垃圾收集器</h1>
<h2>Stop the world（STW）</h2>
<ul>
<li>意思指GC时，停顿所有java执行线程</li>
<li>因为在进行可达性分析时候，如果同时对象引用进行变化，那么这样可达性分析就不正确。这是stop the world 的重要原因</li>
</ul>
<h2>Serial收集器</h2>
<ul>
<li>用一条线程去完成垃圾收集工作</li>
<li>垃圾收集时，需要暂停其他工作线程，显然这是不好，所以缩短线程停顿的时间是一个研究重点</li>
<li>采用复制算法，用于新生代</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwNjA0NTIyLTE2MzUyNjUwMzEucG5n.jpg" /></p>
<h2>Serial Old收集器</h2>
<ul>
<li>与Serial收集器类似</li>
<li>采用标记整理算法，用于老年代</li>
</ul>
<h2>ParNew收集器</h2>
<ul>
<li>用多条线程去完成收集工作</li>
<li>垃圾收集时，需要暂停其他工作线程</li>
<li>默认开启的收集线程数和cpu数量一样，ParallelGCThreads参数可以用来设置线程数</li>
<li>用于新生代，复制算法</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwNjE1ODM0LTM0OTQyNzU1Ni5wbmc=.jpg" /></p>
<h2>Parallel Scavenge收集器</h2>
<ul>
<li>新生代收集器，使用复制算法</li>
<li>关注吞吐量，吞吐量=代码运行时间/(代码运行时间+垃圾收集时间),也就是高效率利用cpu时间，尽快完成程序的运算任务</li>
<li>MaxGCPauseMillis参数设置最大停顿时间，GCTimeRatio设置吞吐量大小</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwODE2NjMxLTE3NzAyNjE0MTEucG5n.jpg" /></p>
<h2>Parllel Old收集器</h2>
<ul>
<li>Parallel Scavenge的老年代版</li>
<li>使用标记整理算法</li>
</ul>
<h2>CMS收集器</h2>
<ul>
<li>用于老年代</li>
<li>关注停顿时间，希望获取最短回收停顿时间</li>
<li>基于标记清除算法，会产生内存碎片</li>
<li>总体来说和用户线程一起并发执行</li>
<li>对cpu资源敏感，也就是会占用较多cpu资源</li>
<li>无法处理浮动垃圾，由于是和用户线程并发执行，所以并发时用户线程产生的的新垃圾（浮动垃圾）无法收集。</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwODQ3MDM3LTc4NTYxMTM4NS5wbmc=.jpg" /></p>
<h2>G1收集器</h2>
<ul>
<li>使用多个cpu来缩短STW（stop the world ）的停顿时间</li>
<li>分代收集</li>
<li>不会产生内存空间碎片</li>
<li>可以建立可预测的停顿时间模型，能够让使用者指定M毫秒时间段内，垃圾收集的时间不超过N毫秒</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkwMDc1MS8yMDE3MDgvOTAwNzUxLTIwMTcwODA0MTIwODU5NTM3LTIwMzM5NTQ0NzIucG5n.jpg" /></p>
<h2>流行的收集器组合</h2>
<table>
<thead>
<tr>
<th>新生代</th>
<th>老年代</th>
</tr>
</thead>
<tbody>
<tr>
<td>Serial</td>
<td>Serial Old</td>
</tr>
<tr>
<td>Serial</td>
<td>CMS</td>
</tr>
<tr>
<td>ParNew</td>
<td>CMS</td>
</tr>
<tr>
<td>ParNew</td>
<td>Serial Old</td>
</tr>
<tr>
<td>Parallel Scavenge</td>
<td>Serial Old</td>
</tr>
<tr>
<td>Parallel Scavenge</td>
<td>Parallel Old</td>
</tr>
<tr>
<td>G1</td>
<td>G1</td>
</tr>
</tbody>
</table>
<h2>垃圾收集参数总结</h2>
<table>
<thead>
<tr>
<th>参数</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>UseSerialGC</td>
<td>虚拟机运行在Client 模式下的默认值，打开此开关后，使用Serial +Serial Old 的收集器组合进行内存回收</td>
</tr>
<tr>
<td>UseParNewGC</td>
<td>打开此开关后，使用ParNew + Serial Old 的收集器组合进行内存回收</td>
</tr>
<tr>
<td>UseConcMarkSweepGC</td>
<td>打开此开关后，使用ParNew + CMS + Serial Old 的收集器组合进行内存回收。Serial Old 收集器将作为CMS 收集器出现Concurrent Mode Failure失败后的后备收集器使用</td>
</tr>
<tr>
<td>UseParallelGC</td>
<td>虚拟机运行在Server 模式下的默认值，打开此开关后，使用ParallelScavenge + Serial Old（PS MarkSweep）的收集器组合进行内存回收</td>
</tr>
<tr>
<td>UseParallelOldGC</td>
<td>打开此开关后，使用Parallel Scavenge + Parallel Old 的收集器组合进行内存回收</td>
</tr>
<tr>
<td>SurvivorRatio</td>
<td>新生代中Eden 区域与Survivor 区域的容量比值， 默认为8， 代表Eden ：Survivor=8∶1</td>
</tr>
<tr>
<td>PretenureSizeThreshold</td>
<td>直接晋升到老年代的对象大小，设置这个参数后，大于这个参数的对象将直接在老年代分配</td>
</tr>
<tr>
<td>MaxTenuringThreshold</td>
<td>晋升到老年代的对象年龄。每个对象在坚持过一次Minor GC 之后，年龄就加1，当超过这个参数值时就进入老年代</td>
</tr>
<tr>
<td>UseAdaptiveSizePolicy</td>
<td>动态调整Java 堆中各个区域的大小以及进入老年代的年龄</td>
</tr>
<tr>
<td>HandlePromotionFailure</td>
<td>是否允许分配担保失败，即老年代的剩余空间不足以应付新生代的整个Eden 和Survivor 区的所有对象都存活的极端情况</td>
</tr>
<tr>
<td>ParallelGCThreads</td>
<td>设置并行GC 时进行内存回收的线程数</td>
</tr>
<tr>
<td>GCTimeRatio</td>
<td>GC 时间占总时间的比率，默认值为99，即允许1% 的GC 时间。仅在使用Parallel Scavenge 收集器时生效</td>
</tr>
<tr>
<td>MaxGCPauseMillis</td>
<td>设置GC 的最大停顿时间。仅在使用Parallel Scavenge 收集器时生效</td>
</tr>
<tr>
<td>CMSInitiatingOccupancyFraction</td>
<td>设置CMS 收集器在老年代空间被使用多少后触发垃圾收集。默认值为68%，仅在使用CMS 收集器时生效</td>
</tr>
<tr>
<td>UseCMSCompactAtFullCollection</td>
<td>设置CMS 收集器在完成垃圾收集后是否要进行一次内存碎片整理。仅在使用CMS 收集器时生效</td>
</tr>
<tr>
<td>CMSFullGCsBeforeCompaction</td>
<td>设置CMS 收集器在进行若干次垃圾收集后再启动一次内存碎片整理。仅在使用CMS 收集器时生效</td>
</tr>
</tbody>
</table>
<h1>内存分配与回收策略</h1>
<h2>GC种类</h2>
<ul>
<li>Minor GC，新生代GC，回收速度快</li>
<li>Major GC/ Full GC , 收集整个堆，包括yong gen，old gen，perm gen，回收速度慢</li>
</ul>
<h2>对象优先分配在新生代中的Eden</h2>
<ul>
<li>大多数情况下，对象分配在Eden区，如果Eden区空间不够，将发起一次MinorGC</li>
</ul>
<h2>大对象直接进入老年代</h2>
<ul>
<li>大对象指需要大量连续内存空间的对象</li>
<li>经常出现大对象，由于需要连续的空间，容易导致内存还有不少空间就提前触发垃圾收集</li>
<li>通过PretenureSizeThreshold参数设置限制，超过这个限制的对象直接分配在老年代</li>
</ul>
<h2>长时间存活的对象将进入老年代</h2>
<ul>
<li>每个对象有一个对象年龄计数器，经过第一次MinorGC进入存货区，年龄为一，以后经过MinorGC还能继续在存活区的话，年龄加一，当通过限制（MaxTenuringThreshold）后会晋升到老年代</li>
</ul>
<h2>动态对象年龄判定</h2>
<ul>
<li>存活区空间相同年龄所有对象大小的总和大于存活区的空间一半，大于等于该年龄的可以直接进入老年代</li>
</ul>
<h2>空间分配担保</h2>
<ul>
<li>Minor GC之前，虚拟机检查老年代最大可用的连续空间是否大于新生代所有对象总空间，如果可以，可以安全进行</li>
<li>如果不行，看是否允许担保失败，不允许的话进行Full GC</li>
<li>允许的话，看老年代的最大可用连续空间是否大于历次晋升老年代对象的平均大小（将之前的作为经验值），如果大于，进行MinorGC，否则进行FullGC</li>
</ul>
<h1>方法区回收</h1>
<h2>回收内容</h2>
<ul>
<li>废弃常量</li>
<li>无用的类</li>
<li>回收的效率不高</li>
</ul>
<h2>废弃常量</h2>
<ul>
<li>没有任何地方引用常量池的字符串常量，必要的话，这个字符串会被清除常量池。常量池中的类 方法 字段的符号引用也是类似</li>
</ul>
<h2>无用的类</h2>
<ul>
<li>不存在该类的任何对象</li>
<li>加载该类的ClassLoader已经被回收</li>
<li>该类的对应的Class对象没有被引用，无法在任何地方通过反射访问该类的方法</li>
</ul>
<h1>gc触发条件</h1>
<h2>ygc</h2>
<ul>
<li>当eden空间不足的时候会触发ygc</li>
</ul>
<h2>full gc</h2>
<ul>
<li>创建大对象时，eden区空间不足，会尝试分配到老年代，如果老年代空间也不足就会触发full gc</li>
<li>触发yong gc的时候，会检查老年代的最大连续空间是否大于新生代所有对象总空间，如果不可以并且不允许担保失败，进行full gc，如果允许担保失败并且老年代的最大可用连续空间小于晋升对象的平均大小，进行full gc</li>
<li>当系统要加载的类，反射的类和调用的方法较多，并且永久代空间不足的话，进行full gc</li>
<li>当to区的空间不足的时候，会把对象复制到老年代，如果老年代空间不足会进行full gc</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 19:38:03 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%85%b3%e6%b3%a8/" title="关注">关注</a>, <a href="https://www.biecuoliao.com/tag/tin/" title="tin">tin</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%a7%e4%ba%8e/" title="大于">大于</a>, <a href="https://www.biecuoliao.com/tag/ges/" title="ges">ges</a>, <a href="https://www.biecuoliao.com/tag/ati/" title="ati">ati</a>, <a href="https://www.biecuoliao.com/tag/%e6%97%a0%e6%b3%95/" title="无法">无法</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%89%e5%85%a8/" title="安全">安全</a>, <a href="https://www.biecuoliao.com/tag/thread/" title="thread">thread</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%82%e6%95%b0%e8%ae%be%e7%bd%ae/" title="参数设置">参数设置</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>jvm系列 (二) ---垃圾收集器与内存分配策略的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jALd7M.html" rel="bookmark">垃圾收集器与内存分配策略&lpar;二&rpar;之垃圾收集算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾收集器与内存分配策略(二)--垃圾收集算法 Java JVM 垃圾回收 简单了解算法的思想 1. 标记-清除算法 标记-清除算法分为标记和清除二个阶段:首先标记出需要回收的对象(详见上一节的可达性分析找出存活对象),在标记完成后统一回收所有被标记的对象. 缺点: 1．标记和清除二个过程的效率都不高 2．空间问题,标记清除后会产生大量不连续的内存碎片,空间碎片太多可能会导致以后再程序运行过程中需要分配较大对象时,无法找到足够的连续内存而不得不提前触发另一次垃圾收集动作. 2. 复制算法 复制算			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AW6Ob0.html" rel="bookmark">垃圾收集器与内存分配策略&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾收集算法简介 1.标记-清除算法       标记-清除算法主要分为“标记”和“清除”两个阶段:首先标记出所有需要回收的对象,在标记完成后统一进行回收.对象的标记过程在垃圾收集器与内存分配策略(一)中已经介绍过. 存在的问题:一是效率问题,标记和清除的效率都不高:二是空间问题,标记清除之后会产生大量不连续的内存碎片,空间碎片太多可能会导致以后在程序运行过程中需要分配较大对象时无法找到足够的内存而不得不提前触发另一次垃圾收集动作. 2.复制算法       复制算法:它将内存按照容量划分为大小			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLPjQyM.html" rel="bookmark">Java虚拟机垃圾收集器与内存分配策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java虚拟机垃圾收集器与内存分配策略 概述 那些内存需要回收,什么时候回收,如何回收是GC需要完成的3件事情. 程序计数器,虚拟机栈与本地方法栈这三个区域都是线程私有的,内存的分配与回收都具有确定性,内存随着方法结束或者线程结束就回收了. java堆与方法区在运行期才知道创建那些对象,这部分内存分配是动态的,本章笔记中分配与回收的内存指的就是:java堆与方法区. 判断对象已经死了 引用计数算法:给对象添加一个引用计数器,每当有一个地方引用它,计数器+1;引用失败,计数器-1.计数器为0则改判			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35Po510.html" rel="bookmark">垃圾收集器与内存分配策略&lpar;三&rpar;之HotSpot的算法实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾收集器与内存分配策略(三)--HotSpot的算法实现 Java JVM 垃圾回收 在HotSpot虚拟机上实现这些算法时,必须对算法的执行效率有着严格的考量,才能保证虚拟机高效地运行. 1. 枚举根节点 采用可达性分析从GC Roots节点中找引用链为例 存在的缺点: 1.在前面找出还存活对象时,采用可达性分析从GC Roots节点中找引用链时,可作为GC Roots的节点主要在全局性的引用(方法区的常量或类静态属性引用)与执行上下文(虚拟机栈栈帧中的本地变量表或本地方法栈中的Native			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41Bw2gM.html" rel="bookmark">垃圾收集器以及内存分配策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾回收 垃圾回收的三个问题: 哪些内存需要回收? 什么时候回收? 如何回收? 1.哪些对象需要回收? 判断对象是否存活的办法: 引用计数算法:给对象中添加一个引用计数器,有一个地方引用就+1,引用失效就-1.只要计数器为0则对象已死. 优点:简单易实现: 缺点:无法解决对象之间相互引用的问题.(JVM也因为此种原因没有使用它) 根搜索算法: 通过选取出一个GC Roots对象,已它作为起始点,如果对象不可达,则对象已死. GC Roots对象: 虚拟机栈中引用的对象 方法区中类静态属性引用的对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OXjD94.html" rel="bookmark">垃圾收集器与内存分配策略&lpar;四&rpar;之垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾收集器与内存分配策略(四)--垃圾收集器 收集算法是内存回收的方法论,垃圾收集器则是内存回收的具体实现. 垃圾收集器介绍 在垃圾收集器的层面上对并行与并发的解释: 并行(Parallel):指多条垃圾收集线程并行工作,但此时用户现场仍处于等待状态. 并发(Concurrent):指用户线程与垃圾收集线程同时执行(但并不一定是并行的,可能会交替执行),用户程序仍在继续执行,而垃圾收集程序运行于另一个CPU上. 对于不同的厂商,不同的版本的虚拟机都可能有很大的差别.此处讨论的是jdk1.7之后的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPO8ky4.html" rel="bookmark">垃圾收集器与内存分配策略&lpar;六&rpar;之内存分配与回收策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾收集器与内存分配策略(六)--内存分配与回收策略 对象的内存分配,一般来说就是在堆上的分配(但也可能经过JIT编译后被拆散为标量类型并间接地栈上分配),对象分配的细节取决于当前使用的是哪一种垃圾收集器组合,还有虚拟机中与内存相关的参数设置. 区分Minor GC与 Full GC: 新生代GC(Minor GC):指发生在新生代的的垃圾收集动作,因为Java对象大多具有朝生夕灭的特性,所以Minor GC非常频繁,一般回收速度也比较快. 老年代GC(Full GC / Major GC):老			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MX17A80.html" rel="bookmark">垃圾收集器与内存分配策略&lpar;五&rpar;之垃圾日志与常见参数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾收集器与内存分配策略(五)--垃圾日志与常见参数 理解GC日志 每个收集器的日志格式都可以不一样,但各个每个收集器的日志都维持一定的共性.如下面二段日志: 33.125: [GC [DefNew: 3324K-&gt;152K(3712K), 0.0025925 secs] 3324K-&gt;152K(11904K), 0.0031680 secs] 100.667: [Full GC [Tenured: 0K-&gt;210K(10240K), 0.0149142 secs] 4603K-&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6yqQG4.html" rel="bookmark">深入理解java虚拟机-----&amp;gt&semi;垃圾收集器与内存分配策略（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.  前言 内存分配与回收策略 JVM堆的结构分析(新生代.老年代.永久代) 对象优先在Eden分配 大对象直接进入老年代 长期存活的对象将进入老年代 动态对象年龄判定 空间分配担保  2.  垃圾收集器与内存分配策略 Java技术体系中所提倡的自动内存管理最终可以归结为自动化地解决两个问题: 给对象分配内存; 回收分配给对象的内存. 对象的内存分配,往大方向上讲就是在堆上的分配,对象主要分配在新生代的Eden区上.少数也可能分配在老年代,取决于哪一种垃圾收集器组合,还有虚拟机中的相关内存的参			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0enVv3.html" rel="bookmark" class="title">clang format 自定义样式常用参数说明</a>
					<div>
						常用的格式设置: #如果为真(true),分析格式化过的文件中最常见的&amp;和*的对齐方式.然后指针对齐仅作为回退 DerivePointerAlignment: false #缩进宽度 Inde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmL2D4.html" rel="bookmark" class="title">NGINX白名单功能，ngx&lowbar;http&lowbar;limit&lowbar;conn&lowbar;module和ngx&lowbar;http&lowbar;limit&lowbar;req&lowbar;module值设置多少才合适呀？</a>
					<div>
						要根据不同的应用慢慢学习测试? 我现在设置的10左右,看看再说吧... #增加限制规则,如果不能正常访问,则需要调节这两个值 --20170217 #增加ip白名单功能 geo $whiteiplis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38NBzAM.html" rel="bookmark" class="title">【leetcode】Merge Intervals</a>
					<div>
						Merge Intervals Given a collection of intervals, merge all overlapping intervals. For example,Given  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nE27pM.html" rel="bookmark" class="title">Hdu 3231 Box Relations（拓扑排序）</a>
					<div>
						题目地址:http://acm.hdu.edu.cn/showproblem.php?pid=3231 思路:拓扑排序.将每个长方体的每对面看成一条线段,将线段看成两个点,则共有3条线段,6个点. 对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bqpvM.html" rel="bookmark" class="title">java新手笔记33 多线程、客户端、服务器</a>
					<div>
						1.Mouse package com.yfs.javase; public class Mouse { private int index = 1; private boolean isLive = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M612vG4.html" rel="bookmark" class="title">Github介绍</a>
					<div>
						Git是一个分布式的版本控制系统,最初由LinusTorvalds编写,用作Linux内核代码的管理.在推出后,Git在其它项目中也取得了很大成功,尤其是在Ruby社区中.包括Rubinius和Mer ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEmog0.html" rel="bookmark" class="title">thinkPHP 点击加载更多</a>
					<div>
						今天做了下点击加载更多,开始使用JSON返回做,可不知道哪里出问题,代码截图,希望可以指点我下 PHP部分: HTML: 这样msg是没数据的:......... 后面换了个办法,没返回json,具体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qdqE3.html" rel="bookmark" class="title">论语《学而第一》</a>
					<div>
						子曰:学而时习之,不亦说乎?有朋自远方来,不亦乐乎?人不知而不愠,不亦君子乎? 有子曰:其为人也孝悌,而好犯上者鲜矣:不好犯上而好作乱者,未之有也.君子务本,本立而道生:孝悌也者,其为人之本与? 子曰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DBzyM.html" rel="bookmark" class="title">关于磁盘，磁柱，磁头，扇区等</a>
					<div>
						图中红色小方块就是扇区,即使它的的面积不等,容量都是512Bytes 蓝色的那一圈就是磁道 一圈有63个扇区 整个一个盘面有1024条磁道 共有256块盘面叠在一起,对应形成1024根磁柱,256根读 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGa6py3.html" rel="bookmark" class="title">Unity学习笔记&lpar;4&rpar; --- Unity的界面排版&colon;初识GUI</a>
					<div>
						GUI和GUILayout是Unity提供的UIKit.在使用GUI的Controls时都要求设置Rect參数.没办法做到自己主动排版,给适配带来难度.而GUILayout的设计就是为了弥补这个缺陷, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWmJz4.html" rel="bookmark" class="title">exchange共存状态下，需要输入版本号登入ECP</a>
					<div>
						exchange 共存状态下(10.13),需要输入版本号登入ECP 例如: https://contoso/ecp/?ExchClientVer=15   登入到2013的ecp					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35wVkjM.html" rel="bookmark" class="title">ConcurrentHashMap的关键部分解析</a>
					<div>
						ConcurrentHashMap是线程安全且高效的HashMap,在多线程情况下,由于HashMap是非线程安全的,容易引起死循环,具体的原因可以自己google一下,这里不做解释,这里只从大的方向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzERRO4.html" rel="bookmark" class="title">jDeveloper运行慢</a>
					<div>
						最近在使用 Jdeveloper 10.1.3.3 版本时发现速度奇慢无比,后经Google,发现如下解决方案:在 jdev.conf 文件的末尾加上如下两行,速度即可得到显著的提高. AddVMOp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvLxB3.html" rel="bookmark" class="title">Step by Step 改进朴素贝叶斯算法</a>
					<div>
						引言 如果你对naive bayes认识还处于初级阶段,只了解基本的原理和假设,还没有实现过产品级的代码,那么这篇文章能够帮助你一步步对原始的朴素贝叶斯算法进行改进.在这个过程中你将会看到朴素贝叶斯假 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkejy3.html" rel="bookmark" class="title">动态添加input标签</a>
					<div>
						&lt;style type=&quot;text/css&quot;&gt;        .delete_attach        {            padding-left: 18px ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35NA514.html" rel="bookmark" class="title">EAX、ECX、EDX、EBX寄存器的作用</a>
					<div>
						注意:在计算加法时,实在32位的累加器上进行,并注意类型之间的转换,数据的截取问题 一般寄存器:AX.BX.CX.DXAX:累积暂存器,BX:基底暂存器,CX:计数暂存器,DX:资料暂存器 索引暂存器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLxvLBM.html" rel="bookmark" class="title">使用visualvm远程监控java进程（以hadoop进程为例）</a>
					<div>
						(一)下载安装 1.下载visualvm 在官网上下载即可,有mac版 2.工具-插件,选择感兴趣的插件进行安装 此时若本地有运行java进程,则在本地那里已经可以进行监控分析 (二)远程服务器配置  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEY6B3.html" rel="bookmark" class="title">自动备份加域工具</a>
					<div>
						大家装系统都装过很多了,公司电脑故障重装系统后都要改电脑名加域,配置磁盘权限.设置邮箱等,在重装系统请都要抄电脑名,ip地址,邮箱用户. 在系统进不去的时候,这些信息只有从其他地方获取了,都是些重复工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qbqRP4.html" rel="bookmark" class="title">Android内存泄漏监测（MAT）及解决办法</a>
					<div>
						http://ttlnews.blogspot.com/2010/01/attacking-memory-problems-on-android.html 这篇文章是2010年1月份写的,其中有些已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xXnaN0.html" rel="bookmark" class="title">TQ2440开发板网络配置方式</a>
					<div>
						一.命令行模式 1.设置IP.子网掩码(netmask) #ifconfig eth0 &lt;IP地址&gt; netmask &lt;子网掩码&gt; up up 表示开启网卡eth0,可以不加  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
